-- scope stuff
gearquipper = gearquipper or {};
local c = gearquipper;

local optionsPanel;

local lblSaveChanges, cbSaveAlways, cbSaveCharMenu, cbSaveGqMenu, cbSaveNever;
local cbHighlightChanges, cbConfirmChangesInChat, cbShowCurrentSetLabel, cbShowItemTooltip;
local btnReset;

function c:InitOptions()
	c.OPT_VERSION = "OPT_VERSION";
	c.OPT_ACTIONBARS = "OPT_ACTIONBARS";
	c.OPT_NOTIFYCHANGES = "OPT_NOTIFYCHANGES";
	c.OPT_HIGHLIGHTCHANGES = "OPT_HIGHLIGHTCHANGES";
	c.OPT_SAVECHANGES = "OPT_SAVECHANGES";
	c.OPT_SLOTSTATES = "OPT_SLOTSTATES";
	c.OPT_SHOWCURRENTSET = "OPT_SHOWCURRENTSET";
	c.OPT_SHOWITEMTOOLTIP = "OPT_SHOWITEMTOOLTIP";

	c.OPT_MENUOPEN = "OPT_MENUOPEN";
	c.OPT_DISABLEEVENTS = "OPT_DISABLEEVENTS";

	c.OPTVALUE_SAVECHANGES_ALWAYS = "OPTVALUE_SAVECHANGES_ALWAYS";
	c.OPTVALUE_SAVECHANGES_CHARMENU = "OPTVALUE_SAVECHANGES_CHARMENU";
	c.OPTVALUE_SAVECHANGES_GQMENU = "OPTVALUE_SAVECHANGES_GQMENU";
	c.OPTVALUE_SAVECHANGES_NEVER = "OPTVALUE_SAVECHANGES_NEVER";

	if GQ_OPTIONS[c.OPT_ACTIONBARS] == nil then
		GQ_OPTIONS[c.OPT_ACTIONBARS] = true;
	end

	if GQ_OPTIONS[c.OPT_NOTIFYCHANGES] == nil then
		GQ_OPTIONS[c.OPT_NOTIFYCHANGES] = true;
	end

	if GQ_OPTIONS[c.OPT_HIGHLIGHTCHANGES] == nil then
		GQ_OPTIONS[c.OPT_HIGHLIGHTCHANGES] = true;
	end

	if GQ_OPTIONS[c.OPT_SLOTSTATES] == nil then
		GQ_OPTIONS[c.OPT_SLOTSTATES] = false;
	end

	if GQ_OPTIONS[c.OPT_SHOWCURRENTSET] == nil then
		GQ_OPTIONS[c.OPT_SHOWCURRENTSET] = true;
	end

	if GQ_OPTIONS[c.OPT_DISABLEEVENTS] == nil then
		GQ_OPTIONS[c.OPT_DISABLEEVENTS] = false;
	end

	if GQ_OPTIONS[c.OPT_SHOWITEMTOOLTIP] == nil then
		GQ_OPTIONS[c.OPT_SHOWITEMTOOLTIP] = true;
	end

	GQ_OPTIONS[c.OPT_SAVECHANGES] = GQ_OPTIONS[c.OPT_SAVECHANGES] or c.OPTVALUE_SAVECHANGES_CHARMENU;

	optionsPanel = CreateFrame("Frame");
	optionsPanel.name = "GearQuipper";
	optionsPanel.okay = function(self) c:SaveOptions(); end;
	optionsPanel.margin = 10;
	optionsPanel.elementIndex = 1;
	optionsPanel.checkboxYOffset = 22;
	InterfaceOptions_AddCategory(optionsPanel);
	optionsPanel:SetScript("OnShow", function()
		c:ShowOptionsPanel();
	end);
	c:ShowOptionsPanel();

	local S = c:GetElvUiSkinModule();
	if S then
		S:HandleFrame(optionsPanel);
	end
end

function c:ShowOptionsPanel()
	if not lblSaveChanges then
		lblSaveChanges = CreateFrame("Frame", "GqUiOptionElement_lblSaveChanges", optionsPanel);
		lblSaveChanges:SetPoint("TOPLEFT", optionsPanel.margin, -(optionsPanel.elementIndex - 1) * optionsPanel.checkboxYOffset - optionsPanel.margin);
		lblSaveChanges:SetWidth(100);
		lblSaveChanges:SetHeight(23);
		lblSaveChanges.fontString = lblSaveChanges:CreateFontString("GqUiOptionElement_lblSaveChanges_FontString", "ARTWORK", "GameFontNormal");
		lblSaveChanges.fontString:SetPoint("LEFT", 3, 0);
		lblSaveChanges.fontString:SetText(c:GetText("Automatically save changes:"));
	end

	if not cbSaveAlways then
		cbSaveAlways = c:CreateOptionCheckButton(c:GetText("Always"), 220);
		cbSaveAlways:SetScript("OnClick", function(self)
			if self:GetChecked() then
				cbSaveCharMenu:SetChecked(false);
				cbSaveGqMenu:SetChecked(false);
				cbSaveNever:SetChecked(false);
			else
				self:SetChecked(true);
			end
		end);
		optionsPanel.elementIndex = optionsPanel.elementIndex + 1;
	end
	cbSaveAlways:SetChecked(GQ_OPTIONS[c.OPT_SAVECHANGES] == c.OPTVALUE_SAVECHANGES_ALWAYS);

	if not cbSaveCharMenu then
		cbSaveCharMenu = c:CreateOptionCheckButton(c:GetText("Character menu open"), 220);
		cbSaveCharMenu:SetScript("OnClick", function(self)
			if self:GetChecked() then
				cbSaveAlways:SetChecked(false);
				cbSaveGqMenu:SetChecked(false);
				cbSaveNever:SetChecked(false);
			else
				self:SetChecked(true);
			end
		end);
		optionsPanel.elementIndex = optionsPanel.elementIndex + 1;
	end
	cbSaveCharMenu:SetChecked(GQ_OPTIONS[c.OPT_SAVECHANGES] == c.OPTVALUE_SAVECHANGES_CHARMENU);

	if not cbSaveGqMenu then
		cbSaveGqMenu = c:CreateOptionCheckButton(c:GetText("GearQuipper menu open"), 220);
		cbSaveGqMenu:SetScript("OnClick", function(self)
			if self:GetChecked() then
				cbSaveAlways:SetChecked(false);
				cbSaveCharMenu:SetChecked(false);
				cbSaveNever:SetChecked(false);
			else
				self:SetChecked(true);
			end
		end);
		optionsPanel.elementIndex = optionsPanel.elementIndex + 1;
	end
	cbSaveGqMenu:SetChecked(GQ_OPTIONS[c.OPT_SAVECHANGES] == c.OPTVALUE_SAVECHANGES_GQMENU);

	if not cbSaveNever then
		cbSaveNever = c:CreateOptionCheckButton(c:GetText("Never"), 220);
		cbSaveNever:SetScript("OnClick", function(self)
			if self:GetChecked() then
				cbSaveAlways:SetChecked(false);
				cbSaveCharMenu:SetChecked(false);
				cbSaveGqMenu:SetChecked(false);
			else
				self:SetChecked(true);
			end
		end);
		optionsPanel.elementIndex = optionsPanel.elementIndex + 1;
	end
	cbSaveNever:SetChecked(GQ_OPTIONS[c.OPT_SAVECHANGES] == c.OPTVALUE_SAVECHANGES_NEVER);

	if not cbHighlightChanges then
		cbHighlightChanges = c:CreateOptionCheckButton(c:GetText("Highlight switched slots"));
		optionsPanel.elementIndex = optionsPanel.elementIndex + 1;
	end
	cbHighlightChanges:SetChecked(GQ_OPTIONS[c.OPT_HIGHLIGHTCHANGES]);

	if not cbConfirmChangesInChat then
		cbConfirmChangesInChat = c:CreateOptionCheckButton(c:GetText("Confirm changes in chat"));
		optionsPanel.elementIndex = optionsPanel.elementIndex + 1;
	end
	cbConfirmChangesInChat:SetChecked(GQ_OPTIONS[c.OPT_NOTIFYCHANGES]);

	if not cbShowCurrentSetLabel then
		cbShowCurrentSetLabel = c:CreateOptionCheckButton(c:GetText("Show \"current set\" label"));
		optionsPanel.elementIndex = optionsPanel.elementIndex + 1;
	end
	cbShowCurrentSetLabel:SetChecked(GQ_OPTIONS[c.OPT_NOTIFYCHANGES]);

	if not cbShowItemTooltip then
		cbShowItemTooltip = c:CreateOptionCheckButton(c:GetText("Show item tooltips"));
		optionsPanel.elementIndex = optionsPanel.elementIndex + 1;
	end
	cbShowItemTooltip:SetChecked(GQ_OPTIONS[c.OPT_SHOWITEMTOOLTIP]);

	if not btnReset then
		btnReset = CreateFrame("Button", "GqResetButton", optionsPanel, "GqButtonTemplate");
		btnReset:SetWidth(180);
		btnReset:SetPoint("TOPLEFT", 10, -optionsPanel.elementIndex * optionsPanel.checkboxYOffset - optionsPanel.margin);
		btnReset:SetScript("OnClick", function() c:ShowResetDialog(); end);
		btnReset.fontString = btnReset:CreateFontString("GqResetButton_FontString", "ARTWORK", "GameFontNormal");
		btnReset.fontString:SetPoint("CENTER");
		btnReset.fontString:SetText(c:GetText("Reset GearQuipper"));

		local S = c:GetElvUiSkinModule();
		if S then
			S:HandleButton(btnReset);
		end
	end
end

function c:CreateOptionCheckButton(text, xOffset)
	xOffset = xOffset or 0;

	local element = CreateFrame("CheckButton", "GqUiOptionElement_" .. optionsPanel.elementIndex, optionsPanel, "ChatConfigCheckButtonTemplate");
	element:SetPoint("TOPLEFT", 10 + xOffset, -(optionsPanel.elementIndex - 1) * optionsPanel.checkboxYOffset - optionsPanel.margin);
	element.fontString = element:CreateFontString("GqUiOptionElement_" .. optionsPanel.elementIndex .. "_FontString", "ARTWORK", "GameFontNormal");
	element.fontString:SetPoint("LEFT", 30, 0);
	element.fontString:SetText(text);

	local S = c:GetElvUiSkinModule();
	if S then
		S:HandleCheckBox(element);
	end

	return element;
end

function c:SaveOptions()
	if c.initFinished then
		GQ_OPTIONS[c.OPT_NOTIFYCHANGES] = cbConfirmChangesInChat:GetChecked();
		GQ_OPTIONS[c.OPT_HIGHLIGHTCHANGES] = cbHighlightChanges:GetChecked();
		GQ_OPTIONS[c.OPT_SHOWCURRENTSET] = cbShowCurrentSetLabel:GetChecked();
		GQ_OPTIONS[c.OPT_SHOWITEMTOOLTIP] = cbShowItemTooltip:GetChecked();

		if cbSaveAlways:GetChecked() then
			GQ_OPTIONS[c.OPT_SAVECHANGES] = c.OPTVALUE_SAVECHANGES_ALWAYS;
		elseif cbSaveCharMenu:GetChecked() then
			GQ_OPTIONS[c.OPT_SAVECHANGES] = c.OPTVALUE_SAVECHANGES_CHARMENU;
		elseif cbSaveGqMenu:GetChecked() then
			GQ_OPTIONS[c.OPT_SAVECHANGES] = c.OPTVALUE_SAVECHANGES_GQMENU;
		else
			GQ_OPTIONS[c.OPT_SAVECHANGES] = c.OPTVALUE_SAVECHANGES_NEVER;
		end
	end
end